// crtez.h - Klase obojenih crteza.

#ifndef _crtez_h_
#define _crtez_h_

#include "pravoug3.h"
#include "niz4.h"

namespace Figure {
  class Crtez: public Pravoug {
    Niz<Figura*> figure;                  // Figure u crtezu.
    void kopiraj (const Crtez& crt);      // Kopiranje crteza.
    void brisi ();                        // Unitavanje crteza.
  public:                                 // Konstruktori.
    explicit Crtez (const Tacka& T,
      double sir, double vis, Boja bb=Boja()):
      Pravoug (T, sir, vis, bb) {}
    Crtez (const Crtez& crt): Pravoug(crt) { kopiraj (crt); }
    Crtez& operator= (const Crtez& crt) { // Dodela vrednosti.
      if (this != &crt) {
        brisi(); Pravoug::operator=(crt); kopiraj (crt);
      }
      return *this;
    }
    ~Crtez () { brisi (); }               // Destruktor.
    Crtez* kopija () const { return new Crtez (*this); } // Kopija.
    Crtez& dodaj (const Figura& fig)      // Dodavanje figure kopiranjem.
      { figure.dodaj (fig.kopija()); return *this; }
    Crtez& dodaj (Figura* fig)            // Dodavanje figure preuzimanjem.
      { figure.dodaj (fig); return *this; }
    Boja boja (const Tacka& T) const;     // Boja tacke.
  }; // class Crtez
} // namespace Figure

#endif
