// izlomljena.h - Klasa izlomljenih linija u ravni.

#ifndef _izlomljena_h_
#define _izlomljena_h_

#include "linija.h"
#include "tacka5.h"

namespace Linije {
  class Izlomljena: public Linija {
  protected:
    Tacka* tem; int n;                      // Niz i broj temena.
  private:
    void kopiraj (const Tacka*, int);       // Kopiranje u objekat.
    void brisi () { delete [] tem; n = 0; } // Unistavanje.
  public:
    Izlomljena (const Tacka* niz, int k)    // Inicijalizacija nizom tacaka.
      { kopiraj (niz, k); }
    Izlomljena (const Izlomljena& lin)      // Inicijalizacija linijom.
      : Linija(lin) { kopiraj (lin.tem, lin.n); }
    ~Izlomljena () { brisi (); }                    // Unistavanje.
    Izlomljena& operator= (const Izlomljena& lin) { // Dodela vrednosti.
      if (this != &lin)
        { brisi (); Linija::operator= (lin); kopiraj (lin.tem, lin.n); }
      return *this;
    }
    double duzina () const;                         // Duzina.
    Izlomljena* kopija () const                     // Dinamicka kopija.
      { return new Izlomljena (*this); }
  private:
    virtual void pisi (ostream& it) const {         // Pisanje.
      Linija::pisi (it); it<< "[izlomljena: ";
      Tacka::pisiNiz (it, tem, n); it<<']';
    }
  };
}

#endif