// lista3.h - Definicija klase lista celih brojeva (rekurzivno).

#include <iostream>
using namespace std;

class Lista {
  struct Elem {                 // Element liste:
    int broj;                   // - sadrzaj,
    Elem* sled;                 // - pokazivac na sledeci,
    Elem (int b, Elem* s=0)     // - konstruktor.
      { broj=b; sled = s; }
  };
  Elem* prvi;                   // Pokazivac na pocetak liste.
public:                         // Konstruktori:
  Lista () { prvi = 0; }        // - podrazumevani,
  Lista (int b)                 // - konverzije,
    { prvi = new Elem (b); }
  Lista (const Lista& lst)      // - kopije.
    { prvi = 0; kopiraj (lst.prvi); }
  ~Lista () { brisi (prvi); }   // Destruktor.
  int duz () const              // Broj elemenata liste.
    { return duz (prvi); }
  void pisi () const            // Ispisivanje liste.
    { pisi (prvi); }
  void naPocetak (int b)        // Dodavanje na pocetak.
    { prvi = new Elem (b, prvi); }
  void naKraj (int b)           // Dodavanje na kraj.
    { naKraj (prvi, b); }
  void citaj1 (int n)  // Citanje stavljajuci brojeve na pocetak.
    { brisi (); citaj1 (prvi, n); }
  void citaj2 (int n)  // Citanje liste stavljajuci brojeve na kraj.
    { brisi (); citaj2 (prvi, n); }
  void umetni (int b)           // Umetanje u uredjenu listu.
    { umetni (prvi, b); }
  void brisi ()                 // Brisanje svih elemenata liste.
    { brisi (prvi); }
  void izostavi (int b)         // Izostavljanje svakog pojavljivanja.
    { izostavi (prvi, b); }
private:                                     // POMOCNE REKURZIVNE METODE:
  static Elem* kopiraj (Elem* lst) {         // Kopiranje liste.
    return lst ? new Elem (lst->broj, kopiraj(lst->sled)) : 0;
  }
  static int duz (Elem* lst)                 // Broj elemenata liste.
    { return lst ? 1+duz(lst->sled) : 0; }
  static void pisi (Elem* lst) {             // Ispisivanje liste.
    if (lst) { cout << lst->broj << ' '; pisi (lst->sled); }
  }
  static void naKraj (Elem*& lst, int b) {   // Dodavanje na kraj.
    if (!lst) lst = new Elem (b);
      else naKraj (lst->sled, b);
  }
  static void citaj1 (Elem*& lst, int n) {   // Citanje stavljajuci na poc.
    if (n) {
      lst = new Elem (0);
      citaj1 (lst->sled, n-1);
      cin >> lst->broj;
    }
  }
  static void citaj2 (Elem*& lst, int n) {   // Citanje stavljajuci na kraj.
    if (n) {
      int b; cin >> b; lst = new Elem (b);
      citaj2 (lst->sled, n-1);
    }
  }
  static void umetni (Elem*& lst, int b) {   // Umetanje u uredjenu listu.
    if (!lst || lst->broj>=b) lst = new Elem (b, lst);
    else umetni (lst->sled, b);
  }
  static void brisi (Elem*& lst) {           // Brisanje svih elemenata.
    if (lst) { brisi (lst->sled); delete lst; lst = 0; }
  }
  static void izostavi (Elem*& lst, int b) { // Izost. svakog pojavlj.
    if (lst) {
      izostavi (lst->sled, b);
      if (lst->broj == b) {
        Elem* stari = lst; lst = lst->sled; delete stari;
      }
    }
  }
};
