// osoba.h - Klasa osoba.

#ifndef _osoba_h_
#define _osoba_h_

#include "datum2.h"
#include <cstring>
#include <iostream>
using namespace std;

class Osoba {
  char* ime;                                     // Ime.
  Datum rodj;                                    // Datum rodjena.
  Osoba (const Osoba&) {}                        // Ne sme da se kopira.
  void operator= (const Osoba&) {}               // Ne sme da se dodlejuje.
public:
  Osoba (const char* ii, const Datum& rr) {      // Konstruktor.
    ime = strcpy (new char [strlen(ii)+1],ii);
    rodj = rr;
  }
  ~Osoba () { delete [] ime; }                   // Destruktor.
  Osoba& staviIme (const char* ii) {             // Menjanje imena.
    delete [] ime;
    ime = strcpy (new char [strlen(ii)+1],ii);
    return *this;
  }
  Osoba& staviRodj (const Datum& rr)              // Menjanje datuma rodj.
    { rodj = rr; return *this; }
  const char* uzmiIme () const { return ime; }    // Dohvatanje imena.
  const Datum& uzmiRodj () const { return rodj; } // Dohvatanje dat. rodj.
protected:
  virtual void pisi (ostream& it) const           // Pisanje.
    { it << ime << " (" << rodj << ')'; }
  friend ostream& operator<< (ostream& it, const Osoba& oso)
    { oso.pisi (it); return it; }
};

#endif
